//    CSE 687 Exercise 1
//                      SSN: 223-61-3010   Name: Gang Cheng
// 
// This is a simple program, similar to exercise 12. pp. 74
//   of the text book, to query the number of days in a
//   specified month. This program needs to be improved by
//   adding free store to minimize the memory allocations
//   for each instance of th class Month.

#include <istream.h> // header file for input
#include <ostream.h> // header file for output

class Month {        // Name class
  int month_id;
 public: // inline construction function, error checking
  Month(int index) {if ((month_id = index)<1 || index>12) {
		      cerr <<"Wrong month id("<< index << ")\n";
		      exit(-1);}
		   }
  int Month_day(void); //member function 1: the number of days in a month
  char* Month_name(void); //member function 2: The name of a month
};

 int Month::Month_day() // member function 1
{     switch (month_id) {
      case 1: case 3: case 5: case 7: case 8: case 10: case 12:
	return 31;
      case 2:
	return 28;
      default:
	return 30;
      };
}

char* Month::Month_name() // member function 2
{
  char* mname[] = {"January","Febuary","March","April","May",
		   "June","July","August","September","October",
		   "November","December"};
  return (mname[month_id - 1]);
}

main() // main program
{ Month m(1);

  cout << "\nIndex         Month\n";
  cout << "--------------------\n";
  for ( int i = 1; i < 13; i++) {
    m.Month(i);
    cout << ' '<<i <<"           "<<m.Month_name()<<"\n";
  }
  cout << ' ' << 0 <<"           Exit";
  int n;
  while (1) {
    cout << "\nChoose an index (0 - 12): ";
    cin >>n;
    if (n == 0) exit(0);
    m.Month(n);
    cout << "Month name: " << m.Month_name() << "\n";
    cout << "Number of days: " << m.Month_day() << "\n";
  }
  exit(-1);
}
